/*******************************************************************************
** 
** Archivo : nex_cookie_api.js   
**
** Autor: CECOM 
**
** Aviso: Reservados todos los derechos. Ninguna parte de esta archivo puede ser 
** reproducida, almacenada en algun sistema reproductor o transmitida en cualquier
** modo o por cualquier medio electronico, mecanico, de fotocomposicion, de 
** grabacion o de otro tipo, sin la previa autorizacion por escrito de los 
** propietarios de los derechos de autor.
**
** Descripcion:
** Esta libreria gestiona las informacion basica del material formativo.
**
*******************************************************************************/


var NEXAPI = ""; 			//-----> API de Cookies
var extAPI = null;			//-----> API de LMS o Cookies si el LMS no existe
var course_structure=""     //-----> Estructura del curso: core_vendor o launch_data

var curso = null; 			//-----> Contendra el arbol de navegacion 

//var scormVersion ="v1.3"  //------>(SCORM2004)
//var dIndex=2 				//-------->diccionario
var scormVersion ="v1.2"  //------>(SCORM 1.2)
var dIndex=1 				//-------->diccionario


var listaObjetivos=new Array();

//Elementos de seguimiento y gestion minimos: diccionario (cookies, scorm1.2, scorm1.3)

var diccionario = new Array(9);
	diccionario[0]= new Array("student_id", "cmi.core.student_id", "cmi.learner_id") //Identificador de Usuario 
	diccionario[1]= new Array("student_name", "cmi.core.student_name", "cmi.learner_name") //Nombre  de Usuario 
	diccionario[2]= new Array("lesson_location", "cmi.core.lesson_location", "cmi.location") //Informacion adicional y de gestion 1000
	diccionario[3]= new Array("suspend_data", "cmi.suspend_data", "cmi.suspend_data") //Informacion adicional y de gestion inicial 4000
	diccionario[4]= new Array("launch_data", "cmi.launch_data", "cmi.launch_data") //Informacion adicional y de gestion inicial
	diccionario[5]= new Array("status", "cmi.core.lesson_status", "cmi.completion_status") //Estado SCO
	diccionario[6]= new Array("score", "cmi.core.score.raw", "cmi.score.raw") //Nota SCO
	diccionario[7]= new Array("mastery_score", "cmi.student_data.mastery_score", "cmi.scaled_passing_score") //Nota de corte SCO
	diccionario[8]= new Array("totalTime", "cmi.core.totalTime", "cmi.total_time") //Tiempo total en la SCO
	diccionario[9]= new Array("idioma", "cmi.student_preference.language", "cmi.student_preference.language") //Idioma por defecto


/******************************************************************************/
/**                             Arbol de navegacion                          **/
/******************************************************************************/

var ct=new String("")  //---> variable general de multiples usos.
var cn=0 			   //---> variable general de multiples usos.

/*******************************************************************************
**
** Constructor Tree(arg1, arg2, arg3)
** Inputs:  @arg1: Nombre o nodo, esto el elemento de la estructura p.ej: "R0" o "P1_1_1"
**          @arg2: Estado del elemento, p.ej:"n" o "i" o "c" o "p" o "f" 
**			@arg3: Parametros del elementos , p.ej: "a" o "a70"
** Return:  none
**
** Description:
** Constructor del arbol de navegacion del curso, genera un arbol mediante el cual nos 
** podremos mover para la gestion de la informacion de estado del material formativo
**
*******************************************************************************/
function Tree(arg1, arg2, arg3){
    this.children = new Array();
    this.nombre = arg1;
    this.parametros = arg2;
	this.estado = arg3;
	
}



/*******************************************************************************
**
** Function  addChild(obj, arg1, arg2, arg3)
** Inputs:  @obj: Rama o nodo del arbol
**			@arg1:nombe de la nueva rama o nodo del arbol
			@arg2:estado de la nueva rama o nodo del arbol
			@arg3:parametro de la nueva rama o nodo del arbol
** Return:  @:object, devuele el objeto de la ultima rama creada
**
** Description:
** Anade una ramo o nodo al arbol de navegacion. 
**
*******************************************************************************/
function addChild(obj, arg1, arg2, arg3, arg4){
	if (obj.children.length < Number(Number(arg4)-1)){
		for (var d=obj.children.length; d<Number(Number(arg4)-1);d++){
			obj.children.push(new Tree("", "", ""));
		}
	}
	obj.children.push(new Tree(arg1, arg2, arg3));
	return obj.children[obj.children.length-1];
}


/*******************************************************************************
**
** Function  getChild(obj)
** Inputs:  @obj: Rama o nodo del arbol
** Return:  @:object, devuele el objeto de la ultima rama creada
**
** Description:
** Devuelve el siguiente nodo del arbol de navegacion. 
**
*******************************************************************************/
function getLastChild(obj){
	return obj.children[obj.children.length-1];
}


/*******************************************************************************
**
** Function  getNodes(n)
** Inputs:  @n: Rama o nodo del arbol
** Return:  none
**
** Description:
** Gestion los estados del nodo o rama actual
**
*******************************************************************************/
function getNodes(n){
		ct=ct+this.estado+";"
}


/*******************************************************************************
**
** Function getBranch(n)
** Inputs:  @n: Rama o nodo del arbol
** Return:  @ct:Cadena con los estados del curso
**
** Description:
** Gestion los estados del nodo actual
**
*******************************************************************************/
function getBranch(n){
		for (var i=0;i<this.children.length;i++) {
			this.children[i].getNodes(n);
			if (this.children[i].children.length) {this.children[i].getBranch(n+1);}
		}
		return ct;
}

// Metodos de Arbol de navegacion

  	//new Tree();
	  Tree.prototype.addChild=addChild;
	  Tree.prototype.getLastChild=getLastChild;
	  Tree.prototype.getBranch=getBranch;
	  Tree.prototype.getNodes=getNodes;


/******************************************************************************/
/**                         Fin Arbol de navegacion                          **/
/******************************************************************************/

 




/*******************************************************************************
**
** Constructor NEXE_API(cookieAPI, externaAPI)
** Inputs:  @cookieAPI: API creada en cookies
**          @externaAPI: API que procede del LMS 
** Return:  none
**
** Description:
** Constructor de la libreria nexeapi, genera la variables globales NEXEAPI, que actua cotra la Cookie y la extAPI,
** que actua contra la LMS, de no exisitir, NEXEAPI y extAPI son iguales.
**
*******************************************************************************/

function NEXE_API(cookieAPI, externaAPI)
{
    NEXAPI = cookieAPI;   
    extAPI = externaAPI
    course_structure = core_vendor;
}




/*******************************************************************************
**
** Function  _NEXGlobalInitialize ()
** Inputs:  none
** Return:  @ans:boolean, determina si se ha podido inicalizar las API's 
**
** Description:
** Inicializa el LMS (extAPI [LMS]) e inicializa la api interna (NEXEAPI [cookies]), con los
** datos de la plataforma. 
**
*******************************************************************************/

function _NEXGlobalInitialize (vendor)
{ 
      
      var ans =false;
      var api = NEXAPI;
      var ansLocal = "";
      var ansLMS = "";
      
      	  if (scormVersion=="v1.2") {
      	  	  ansLMS = extAPI.LMSInitialize("");
      	  	  ansLocal = api.LMSInitialize("");
      	  }
      	  else if (scormVersion=="v1.3") {
      	      ansLMS = extAPI.Initialize("");
       	  	  ansLocal = api.Initialize("");
		  }
     if (ansLMS == "false")
	 {
	   ans=false;
	 }	
	 else
	 {
	   ans=true;
	   if (api != extAPI)
	   { 
	      
	      //Esto es temporal hasta que la gente de campus arregle el problema.
	      //_NEXSetValue(diccionario[3][0],_NEXLMSGetValue(diccionario[2][dIndex]).split(".")[0]); // suspend_data
	      //_NEXSetValue(diccionario[2][0],_NEXLMSGetValue(diccionario[2][dIndex]).split(".")[1]); // lesson_location
	      //El bueno seria esto
	      _NEXSetValue(diccionario[3][0],_NEXLMSGetValue(diccionario[3][dIndex])); // suspend_data
	      _NEXSetValue(diccionario[2][0],_NEXLMSGetValue(diccionario[2][dIndex])); // lesson_location
	      
	      _NEXSetValue(diccionario[5][0],_NEXLMSGetValue(diccionario[5][dIndex])); //Status SCO	       
	      _NEXSetValue(diccionario[6][0],_NEXLMSGetValue(diccionario[6][dIndex])); //Score
	      _NEXSetValue(diccionario[7][0],_NEXLMSGetValue(diccionario[7][dIndex])); //Mastery-Score
   	      _NEXSetValue(diccionario[9][0],_NEXLMSGetValue(diccionario[9][dIndex])); //Mastery-Score
	   }
	  
	   //Comprobamos la existencia o no de datos de usuario:
	   if ( _NEXGetValue(diccionario[3][0])=="") _NEXInitializeCourse();
	   else _NEXPrepareCourse();
    }
	
	return ans
}


/*******************************************************************************
**
** Function  _NEXGlobalCommit()
** Inputs:  none
** Return:  @ans:boolean, determina si se ha podido hacer el comit las API's 
**
** Description:
** Guarda los datos en el LMS (extAPI [LMS]) segun los datos (NEXEAPI [cookies]), con los
** datos de la plataforma. 
**
*******************************************************************************/
function _NEXGlobalCommit()
{
          var ans =false;
      	  var api = NEXAPI;
	      var ansLocal = "";
          var ansLMS = "";
          
	 	 _NEXPrepareData(); 
	 	  
	 if (api != extAPI)
	 { 
	    
	     //Esto es temporal hasta que la gente de campus arregle el problema.
	       //_NEXLMSSetValue(diccionario[2][dIndex],_NEXGetValue(diccionario[3][0])+"."+_NEXGetValue(diccionario[2][0])); // lesson_location
	     //El bueno seria esto
	      _NEXLMSSetValue(diccionario[2][dIndex],_NEXGetValue(diccionario[2][0])); // lesson_location
	      _NEXLMSSetValue(diccionario[3][dIndex],_NEXGetValue(diccionario[3][0])); // suspend_data
	     
	       _NEXLMSSetValue(diccionario[5][dIndex],_NEXGetValue(diccionario[5][0])); // //Status SCO
	       _NEXLMSSetValue(diccionario[6][dIndex],_NEXGetValue(diccionario[6][0])); // //Score		    
	       //_NEXLMSSetValue(diccionario[8][dIndex],api._guardarTiempo()); // Tiempo total.		    
	 }
	  
	 
      	  if (scormVersion=="v1.2") {
      	   	ansLMS = extAPI.LMSCommit("");
      	  	ansLocal = api.LMSCommit("");
      	  }
      	  else if (scormVersion=="v1.3") {
      	      ansLMS = extAPI.Commit("");
       	      ansLocal = api.Commit("");
	  }
	  
	  if (ansLMS == "false"){
	      ans=false;
	   }	
	  else {
	      ans=true;
	  }
	  return ans
}


/*******************************************************************************
**
** Function  _NEXGlobalFinish()
** Inputs:  none
** Return:  @ans:boolean, determina si se ha podido hacer el Finish las API's 
**
** Description:
** Finaliza la comunicacion con las Apis. 
**
*******************************************************************************/
function _NEXGlobalFinish() {
          var ans =false;
      	  var api = NEXAPI;
	  var ansLocal = "";
          var ansLMS = "";
	 
	  if (scormVersion=="v1.2") {
      	   	ansLMS = extAPI.LMSFinish("");
      	  	ansLocal = api.LMSFinish("");
      	  }
      	  else if (scormVersion=="v1.3") {
      	      ansLMS = extAPI.Terminate("");
       	      ansLocal = api.Terminate("");
	  }
	  
	  if (ansLMS == "false"){
	      ans=false;
	   }	
	  else {
	      ans=true;
	  }
	  return ans
}


/*******************************************************************************
**
** Function  _NEXGlobalGetValue(item)
** Inputs:  @item: Elemento del diccionario a consultar
** Return:  String con el valor devuelto
**
** Description:
** Recupera el valor del Modelo de datos.
**
*******************************************************************************/
function _NEXGlobalGetValue(item)
{
		
		var api = NEXAPI;
		var aux= new String("");
		if (api != extAPI)
		{
        	aux=_NEXLMSGetValue(diccionario[item][dIndex]);
		}
		else {
			aux=_NEXGetValue(diccionario[item][0])
		}
		return aux;
}

/*******************************************************************************
**
** Function  _NEXLMSGetValue(parameter)
** Inputs:  @parameter: Elemento a consultar
** Return:  String con el valor devuelto
**
** Description:
** Recupera el valor del Modelo de datos.
**
*******************************************************************************/
function _NEXLMSGetValue(parameter)
{ 
     var ansLMS = ""; 
      	  if (scormVersion=="v1.2") {
      	      ansLMS = extAPI.LMSGetValue(parameter);
      	  }
      	  else if (scormVersion ="v1.3") {
      	      ansLMS = extAPI.GetValue(parameter);
		  }
	return ansLMS 
}


/*******************************************************************************
**
** Function  _NEXLMSSetValue(parameter, value)
** Inputs:  @parameter: Elemento a guardar
**			@value: Valor a guardar
** Return:  String con true o false, true, si he finalizado bien el guardar datos
** o false en caso contrario.
**
** Description:
** Salva el valor parametro de Modelo de datos.
**
*******************************************************************************/
function _NEXLMSSetValue(parameter, value)
{ 
     var ansLMS = ""; 
      	  if (scormVersion=="v1.2") {
      	  			
      	      ansLMS = extAPI.LMSSetValue(parameter, value.toString());
      	  }
      	  else if (scormVersion ="v1.3") {
      	      ansLMS = extAPI.GetValue(parameter, value);
		  }
	return ansLMS 
}




/*******************************************************************************
**
** Function  _NEXGetValue(parameter)
** Inputs:  @parameter: Elemento a consultar
** Return:  String con el valor devuelto
**
** Description:
** Recupera el valor del Modelo de datos interno (cookies).
**
*******************************************************************************/
function _NEXGetValue(parameter)
{   
     var api = NEXAPI;
     var ansLocal = ""; 
      	  if (scormVersion=="v1.2") {
      	      ansLocal = api.LMSGetValue(parameter);
      	  }
      	  else if (scormVersion=="v1.3") {
      	      ansLocal = api.GetValue(parameter);
		  }
	return ansLocal
}


/*******************************************************************************
**
** Function  _NEXSetValue(parameter, value)
** Inputs:  @parameter: Elemento a guardar
**	    @value: Valor a guardar
** Return:  String con true o false, true, si he finalizado bien el guardar datos
** o false en caso contrario.
**
** Description:
** Salva el valor parametro de Modelo de datos interno (cookies).
**
*******************************************************************************/
function _NEXSetValue(parameter, value)
{  
	 var api = NEXAPI;
     var ansLocal = "";
      	  if (scormVersion=="v1.2") {
      	      ansLocal = api.LMSSetValue(parameter, value);
      	  }
      	  else if (scormVersion=="v1.3") {
      	  	  ansLocal = api.SetValue(parameter, value);
		  }
	return ansLocal 
}


/*******************************************************************************
**
** Function  _NEXInitializeCourse()
** Inputs:  none
** Return:  none
**
** Description:
** Inicializa los datos del curso
**
*******************************************************************************/
function _NEXInitializeCourse(vendor)
{       
		
		//setAction("_NEXInitializeCourse");
		var api = NEXAPI;
		var aux= new String("");
			if (api != extAPI)
			{
	        aux=_NEXLMSGetValue(diccionario[4][dIndex])==""?course_structure:_NEXLMSGetValue(diccionario[4][dIndex]); //Estructura R0,a;...
			}
			else {
			aux=_NEXGetValue(diccionario[4][0])==""?course_structure:_NEXGetValue(diccionario[4][0]); //Estructura R0,a;...
			}
		var aux_array=aux.split(";");
		
		var aux2=aux_array[0].split(",");
		var aux3=aux2[0].toString().toUpperCase();
		var aux4=aux3.split("_");
		var aux5=aux2[1].toString().toUpperCase()
		
		curso=new Tree(aux3, aux5,  "n"); 
		for (var count=1; count<aux_array.length-1;count++){
				aux2=aux_array[count].split(",");
			    aux3=aux2[0].toString().toUpperCase();
			    aux4=aux3.split("_");
			    aux5=aux2[1].toString().toUpperCase();
			    aux6=aux4[0].substr(1,aux4[0].length);
			    	p=curso;
			   		for (var z=1; z<aux4.length;z++){
			   			p=p.children[p.children.length-1]
			   			 aux6=aux4[z];
					}
			   		//alert("tomas: "+p.nombre+ "|" + aux3 + "|" + aux6);
			   		p.addChild(p, aux3, aux5, "n", aux6);
		}
		 
       _NEXPrepareData(); //---> Gestionamos guardar los datos inicializados de la cadena de estados. 
}





function _NEXPrepareCourse(){

        //setAction("_NEXPrepareCourse");
		var api = NEXAPI;
		var aux = new String(""); //--->Estructura
		var aux2= new String(""); //--->Estados
		
		if (api != extAPI)
		{
        aux=_NEXLMSGetValue(diccionario[4][dIndex])==""?course_structure:_NEXLMSGetValue(diccionario[4][dIndex]); //Estructura R0,a;...
		}
		else {
		aux=_NEXGetValue(diccionario[4][0])==""?course_structure:_NEXGetValue(diccionario[4][0]); //Estructura R0,a;...
		}
		
		var aux_array=aux.split(";");  //--->Array con la estructura
	 	
		if (api != extAPI)
		{
        //aux2=_NEXLMSGetValue(diccionario[3][dIndex]); //Estados...
        aux2=_NEXGetValue(diccionario[3][0]); //Estados....

		}
		else {
		aux2=_NEXGetValue(diccionario[3][0]); //Estados....
		}

		var aux2_array=aux2.split(";");  //--->Array con los estados
		
		var aux3=aux_array[0].split(",");
		var aux4=aux3[0].toString().toUpperCase();
		var aux5=aux4.split("_");
		var aux6=aux3[1].toString().toUpperCase()
		
		curso=new Tree(aux4, aux6,  aux2_array[0]); 
	    for (var count=1; count<aux_array.length-1;count++){
				aux3=aux_array[count].split(",");
			    aux4=aux3[0].toString().toUpperCase();
			    aux5=aux4.split("_");
			    aux6=aux3[1].toString().toUpperCase();
			    aux7=aux5[0].substr(1,aux5[0].length);

					p=curso;
			   		for (var z=1; z<aux5.length;z++){
			   			p= p.children[p.children.length-1]
			   			aux7=aux5[z];

			   		}
			   		p.addChild(p, aux4, aux6, aux2_array[count], aux7);
		}
}



/*******************************************************************************
**
** Function  _NEXPrepareData()
** Inputs:  none
** Return:  none
**
** Description:
** Establece los datos del suspend_data del alumno.
**
*******************************************************************************/
function _NEXPrepareData(){
     	  //setAction("_NEXPrepareData");
		  ct=new String(curso.estado+";")
		  var aux=curso.getBranch(0);
		 _NEXSetValue(diccionario[3][0],aux); //---> suspend_data [cookies]
		 
}

/*******************************************************************************
**
** Function  _NEXFindItem(item)
** Inputs:  @item: Elemento a localizar (pagina...bloque)
** Return:  @ans:object --> Devuelve el objeto a buscar, y si no lo encuentra devuelve false;
**
** Description:
** Localiza el elemento que se solicita en el arbol de navegacion
**
*******************************************************************************/
function _NEXFindItem(item)
{
   	//setAction("_NEXFindItem("+item+")");
		var ans=false;
		var aux=item.toUpperCase();
		if (aux=="R0") {
			if (curso.nombre==aux) ans=curso;
		}		
		else{
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   			    p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La busqueda del elemento: "+item+" ha generado el siguiente error: "+ String(exception));
      						ans=false
      					}
		   			}
			   		if (p)ans=p;
			   		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
		}
		return ans		
}

/*******************************************************************************
**
** Function  _NEXFindParentItem(item)
** Inputs:  @item: Elemento a localizar (pagina...bloque)
** Return:  @ans:object --> Devuelve el objeto padre del buscado y si no lo encuentra devuelve false;
**
** Description:
** Localiza el elemento padre del que se solicita en el arbol de navegacion 
** p.Ej: Se solicita p6_1_3, devolvera b6_1
**
*******************************************************************************/
function _NEXFindParentItem(item){
	   	//setAction("_NEXFindParentItem("+item+")");
		var ans=false;
		var prev=null;
		var aux=item.toUpperCase();
		if (aux=="R0") {
			if (curso.nombre==aux) ans=false;
		}		
		else{
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p
			   				p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La busqueda del parent del elemento: "+item+" ha generado el siguiente error: "+ String(exception));
      						ans=false
      					}
		   			}
					if (p)ans=prev;
					//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
		}
		return ans	
}


/*******************************************************************************
**
** Function  _NEXFindChildrenItem(item,indice)
** Inputs:  @item: Elemento a localizar (bloque)
**			@indice: Numero de hijo a devolver
** Return:  @ans:object --> Devuelve el objeto hijo buscado y si no lo encuentra devuelve false;
**
** Description:
** Localiza el elemento hijo que se solicita mediante el valor de indice en el arbol de navegacion 
** p.Ej: Se solicita B6,1 --> devolvera b6_2 que es el elemento que ocupa la rama 1 del arbol que pende de b6...
**
*******************************************************************************/
function _NEXFindChildrenItem(item,indice){
		//setAction("_NEXFindChildrenItem("+item+")");
		if (!indice) indice=0;
		var ans=false;
		var prev=null;
		var aux=item.toUpperCase();
		if (aux=="R0") {
			if (curso.nombre==aux){
				if (curso.children.length>0) p=curso.children[indice];
			}
		}		
		else{
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p
			   				p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La busqueda del parent del elemento: "+item+" ha generado el siguiente error: "+ String(exception));
      						ans=false
      					}
		   			}
		   			if (p){
		   			  if (p.children.length>0) p=p.children[indice];
		   			  }
		   			  
		}
		if (p)ans=p;
		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
		return ans	


}

/*******************************************************************************
**
** Function  _NEXFindSecuentItem(item)
** Inputs:  @item: Elemento a localizar (pagina...bloque)
** Return:  @ans:object --> Devuelve SIGUIENTE objeto del buscado y si no lo encuentra devuelve false;
**
** Description:
** Localiza el seguiente elemento del que se solicita en el arbol de navegacion 
** p.Ej: Se solicita p6_1_3, devolvera p6_1_4;
**
*******************************************************************************/
function _NEXFindSecuentItem(item){
	//setAction("_NEXFindSecuentItem("+item+")");
    var it=item.substr(1,item.length);
	var ans=false
	var p=_NEXFindParentItem(item);
	if (p){
		var	aux=it.split("_");
		var aux2=aux[aux.length-1];
			for (var d=Number(aux2);d<p.children.length;d++){
				if (p.children[d].nombre!=""){
				ans=p.children[d]
				break;
				}
			}
	}
	//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
	return ans;
}


/*******************************************************************************
**
** Function  _NEXFindPrevItem(item)
** Inputs:  @item: Elemento a localizar (pagina...bloque)
** Return:  @ans:object --> Devuelve el ANTERIOR objeto del buscado y si no lo encuentra devuelve false;
**
** Description:
** Localiza el elemento anterior del que se solicita en el arbol de navegacion 
** p.Ej: Se solicita p6_1_4, devolvera p6_1_3;
**
*******************************************************************************/
function _NEXFindPrevItem(item){
	//setAction("_NEXFindPrevItem("+item+")");
    var it=item.substr(1,item.length);
	var ans=false
	var p=_NEXFindParentItem(item);
	if (p){
		var	aux=it.split("_");
		var aux2=aux[aux.length-1];
			for (var d=Number(aux2)-2;d>=0;d--){
				if (p.children[d].nombre!=""){
				ans=p.children[d]
				break;
				}
			}
	}
	//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
	return ans;
}



/*******************************************************************************
**
** Function  _NEXCountChildItem(item)
** Inputs:  @item: Elemento a localizar (pagina...bloque)
** Return:  @ans:array --> Devuelve la lista de paginas del bloque;
**
** Description:
** Devuelve la lista de paginas del elemento item. 
**
*******************************************************************************/
function _NEXCountChildItem (item){
	//setAction("_NEXCountChildItem("+item+")");
	//Profundidad del arbolo respecto al item
	var ans=false;
	var count=0;
	var p=_NEXFindItem(item)
	if (p){
		var listp= new Array();
			for (var z=0;z<p.children.length;z++){
				
				if (p.children[z].children.length>0){
					for (var zz=0;zz<p.children[z].children.length;zz++){
					
						if (p.children[z].children[zz].children.length>0){
							for (var zzz=0;zzz<p.children[z].children[zz].children.length;zzz++){
						
							 	if (p.children[z].children[zz].children[zzz].children.length>0){
								 	for (var zzzz=0;zzzz<p.children[z].children[zz].children[zzz].children.length;zzzz++){
										if (p.children[z].children[zz].children[zzz].children[zzzz].children.length>0){
											alert('Caso no contemplado') //--->Se pueden anadir mas profundidades.
										}
										else  {
											if (p.children[z].children[zz].children[zzz].children[zzzz].nombre!="")  listp.push(p.children[z].children[zz].children[zzz].children[zzzz].nombre);
											}
								 	}
								}
								else {
									if (p.children[z].children[zz].children[zzz].nombre!="") listp.push(p.children[z].children[zz].children[zzz].nombre);
									}
							}
						}
						else {
							if (p.children[z].children[zz].nombre!="") listp.push(p.children[z].children[zz].nombre);
							}
					}				
				}
				else {
					if (p.children[z].nombre!="") listp.push(p.children[z].nombre);
					}
			}
			ans=listp;
	}
	//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
	return ans;

}


/*******************************************************************************
**
** Function  _NEXCountFirstChildItem(item)
** Inputs:  @item: Elemento a localizar (bloque)
** Return:  @ans:array --> Devuelve la lista de subelementos de primer nivel;
**
** Description:
** Devuelve la lista de las ramas que penden del elemento item. 
**
*******************************************************************************/
function _NEXCountFirstChildItem(item){
			var ans=false;
			var aux=item.toUpperCase();
			var count=0;
			var p=_NEXFindItem(item)
			if (p){
				var listp= new Array();
					for (var z=0;z<p.children.length;z++){
						if (p.children[z].nombre!="") listp.push(p.children[z].nombre);

					}
				ans=listp;
			}
			return ans;
}

/*******************************************************************************
**
** Function  _NEXInitialize (item)
** Inputs:  @item: Elemento a inicializar (pagina, bloque)
** Return:  none
**
** Description:
** Cambia el estado de No Iniciado (N) a Iniciado (I). Este cambio no solo se
** ejecuta en el elemento recibido (item) sino que se propaga por todo el arbol
**
*******************************************************************************/
function _NEXInitialize (item)
{
   	//setAction("_NEXInitialize("+item+")");
   		var aux=item.toUpperCase();
   		var prev=null;
		if (aux=="R0") {
			if (curso.estado=="n") curso.estado="i";
		}		
		else{
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p;
			   			    p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La inicializacion del elemento: "+item+" ha generado el siguiente error: "+ String(exception));   						
      					}
		   			}
			   		if (p){
			   			//alert("NEXInitialize  p.nombre: " +p.nombre+ "| p.estado: "+ p.estado)
			   			if (p.estado=="n") {
			   				p.estado="i"; 
			   			    //alert("NEXInitialize2  p.nombre: " +p.nombre+ "| p.estado: "+ p.estado)
			   				_NEXInitialize (prev.nombre)
			   			}
			   		}
			   		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
		}
}


/*******************************************************************************
**
** Function _NEXLoadPage(item)
** Inputs:  @item: Elemento a inicializar (pagina)
** Return:  none
**
** Description:
** Cambia el estado de No Iniciado (N) a Iniciado (I) de la pagina. Este cambio no solo se
** ejecuta en el elemento recibido (item) sino que se propoaga por todo el arbol
**
*******************************************************************************/
function _NEXLoadPage(item)
{
     //setAction("_NEXLoadPage("+item+")");
	_NEXInitialize (item)
}

/*******************************************************************************
**
** Function _NEXUnLoadPage(item, score)
** Inputs:  @item: Elemento a finalizar (pagina)
**			@score:Puntuacion de la pagina... puede ser nulo en el caso de pagina de teoria
** Return:  none
**
** Description:
** Cambia el estado a C, Px, Fx de la pagina, siendo x el valor numerico. Este cambio SOLO se
** ejecuta en el elemento recibido (item) NO que se propoaga por todo el arbol, y en el caso de actividades
** solo se ejecuta si score es mejor que la nota actual.
**
*******************************************************************************/
function _NEXUnLoadPage(item,score){
	
	//setError("_NEXUnLoadPage("+item+","+score+")");
	var aux=item.toUpperCase();
		if (aux.substr(0,1)=="P"){
			  _NEXFinishActivity(item,"");
			  }
		else{
		  _NEXFinishActivity(item,score);
		  }
}

/*******************************************************************************
**
** Function _NEXFinishActivity(item, score)
** Inputs:  @item: Elemento a finalizar (pagina)
**			@score:Puntuacion de la pagina... puede ser nulo en el caso de pagina de teoria
** Return:  none
**
** Description:
** Cambia el estado a C, Px, Fx de la pagina, siendo x el valor numerico. Este cambio SOLO se
** ejecuta en el elemento recibido (item) NO que se propoaga por todo el arbol, y en el caso de actividades
** solo se ejecuta si score es mejor que la nota actual.
**
*******************************************************************************/
function _NEXFinishActivity(item,nt){
	var nota=new String(nt);
	//alert("_NEXFinishActivity("+item+","+nota+")");
	if (nota) nota=nota.toString();
	//alert("_NEXFinishActivity("+item+","+nota+")");
	
	//setAction("_NEXFinishActivity("+item+","+nota+")");
	var aux=item.toUpperCase();
   		var prev=null;
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p;
			   			    p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La finalizacion del elemento: "+item+" ha generado el siguiente error: "+ String(exception));   						
      					}
		   			}
			   		if (p){
			   			//alert("_NEXFinishActivity "+ p.nombre + " | " +nota);
			   			if (nota) {
			   				var aux2=p.parametros
			   				var aux3=-1;
			   				if (aux2.toLowerCase()=="a"){ //---> Habra que buscar la nota de corte.
			   					aux3=_NEXGetValue(diccionario[7][0])==""?50:_NEXGetValue(diccionario[7][0]);
			   				}
			   				else if (aux2.toLowerCase().indexOf("a")!=-1){ //---> Habra que extraer la nota de corte.
			   					aux3=aux2.toLowerCase().substr(1,aux2.toLowerCase().length);
			   				}
			   				else {
			   					setError("El elemento: "+item+" no acepta la propedad nota");   						
			   				}
							if (aux3!=-1){ //Si hay nota de corte
								if (Number(nota)<Number(aux3)){ //Si la nota es inferior a la nota de corte
										if (p.estado=="i") p.estado="f"+nota;  //---> Si estaba incompleto se guarda la nota
										else { //--->Si ya tenia una nota, miramos si era menor, en caso afirmativo se actualiza.
											var aux4=p.estado
											aux4=aux4.substr(1,aux4.length);
											if (Number(aux4)<Number(nota)) p.estado="f"+nota;	
										}
								}
								else { //Si la nota es superio a la nota de corte
									    if (p.estado=="i") p.estado="p"+nota;  //---> Si estaba incompleto se guarda la nota
										else { //--->Si ya tenia una nota, miramos si era menor, en caso afirmativo se actualiza.
											var aux4=p.estado
											aux4=aux4.substr(1,aux4.length);
											if (Number(aux4)<Number(nota)) p.estado="p"+nota;	
										}
								}
							}
							
			   			}
			   			else { //---> Si no hay nota, se entiende que era teorica la pagina y se guarda un C
			   				p.estado="c";
			   				_NEXFinish (prev.nombre)
			   			}
			   			
			   		}
			   		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");

}



/*******************************************************************************
**
** Function _NEXForceActivity(item, nota)
** Inputs:  @item: Elemento a finalizar (pagina)
**			@nota:Puntuacion de la pagina... puede ser nulo en el caso de pagina de teoria
** Return:  none
**
** Description:
** Cambia el estado a C, Px, Fx de la pagina, siendo x el valor numerico. Este cambio SOLO se
** ejecuta en el elemento recibido (item) NO se propoaga por todo el arbol.
**
*******************************************************************************/
function _NEXForceActivity(item,nt){
		var nota=new String(nt);
	//alert("_NEXFinishActivity("+item+","+nota+")");
	if (nota) nota=nota.toString();
	//alert("_NEXFinishActivity("+item+","+nota+")");

	//setAction("_NEXForceActivity("+item+","+nota+")");
	var aux=item.toUpperCase();
   		var prev=null;
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p;
			   			    p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La finalizacion del elemento: "+item+" ha generado el siguiente error: "+ String(exception));   						
      					}
		   			}
			   		if (p){
			   			if (nota!="") {
			   				var aux2=p.parametros
			   				var aux3=-1;
			   				if (aux2.toLowerCase()=="a"){ //---> Habra que buscar la nota de corte.
			   					aux3=_NEXGetValue(diccionario[7][0])==""?50:_NEXGetValue(diccionario[7][0]);
			   				}
			   				else if (aux2.toLowerCase().indexOf("a")!=-1){ //---> Habra que extraer la nota de corte.
			   					aux3=aux2.toLowerCase().substr(1,aux2.toLowerCase().length);
			   				}
			   				else {
			   					//setError("El elemento: "+item+" no acepta la propedad nota");   						
			   				}
							
							if (aux3!=-1){ //Si hay nota de corte
								if (Number(nota)<Number(aux3)){ //Si la nota es inferior a la nota de corte
										 p.estado="f"+nota;	
								}
								else { //Si la nota es superio a la nota de corte
									    p.estado="p"+nota;	
								}
							}
			   			}
			   			else { //---> Si no hay nota, se entiende que era teorica la pagina y se guarda un C
			   				p.estado="c";
			   			}

			   		}
			   		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");

}

/*******************************************************************************
**
** Function _NEXFinish(item)
** Inputs:  @item: Elemento a finalizar (pagina)
** Return:  none
**
** Description:
** Calcula el estado final del elemento se propaga por el arbol.
**
*******************************************************************************/
function _NEXFinish(item){

//setAction("_NEXFinish2("+item+")");
	var aux=item.toUpperCase();
	var zaun=aux;
   		var prev=null;
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					if (zaun!="R0"){
						for (var z=0; z<aux_array.length;z++){
							try{
				   				prev=p;
				   			    p=p.children[Number(Number(aux_array[z])-1)];
							}
							catch (exception) {
							    p=null
							    //setError("La finalizacion del elemento: "+item+" ha generado el siguiente error: "+ String(exception));   						
	      					}
			   			}
		   			}
			   		if (p){
			   				
			   				var aux2=p.parametros
			   				var aux3=-1; //--->Nota de corte
			   				if (aux2.toLowerCase()=="a"){ //---> Habra que buscar la nota de corte.
			   					aux3=_NEXGetValue(diccionario[7][0])==""?50:_NEXGetValue(diccionario[7][0]);
			   				}
			   				else if (aux2.toLowerCase().indexOf("a")!=-1){ //---> Habra que extraer la nota de corte.
			   					aux3=aux2.toLowerCase().substr(1,aux2.toLowerCase().length);
			   				}
			   				else { //--->No hay nota de corte, es un bloque de teoria.
			   					aux3=-1  						
			   				}
			   				
			   				//Calculamos la nota media de los elementos de que se compone el bloque
			   				var puntuacion=0;
			   				var std="c"
			   				var counter=0;
			   				for (var z=0; z<p.children.length;z++){
			   					f=p.children[z];
			   					var aux4=f.estado;
			   						if ((aux4.toLowerCase()=="n") || (aux4.toLowerCase()=="i")){
			   							std="i";
			   							puntuacion=-1;
			   						}
			   						else {
			   							if (aux4.toLowerCase()=="c"){
			   								puntuacion=Number(puntuacion)+0;			
			   							}
			   							else {
			   								counter++;
			   								var aux5=aux4.substr(1,aux4.length)
			   								puntuacion=Number(puntuacion)+Number(aux5);	
			   							}
			   						}
			   				}
			   				if (puntuacion==-1) p.estado=std;
			   				else {
			   					if (puntuacion!=0) {
				   					nota=parseInt(Number(Number(puntuacion)/Number(counter)), 10);
				   					if (Number(nota)<Number(aux3)){ //Si la nota es inferior a la nota de corte
											 p.estado="f"+nota;	
									}
									else { //Si la nota es superior a la nota de corte
										    p.estado="p"+nota;	
									}
								}
								else {
									if (aux3==-1) p.estado="c"
									else p.estado="f0";
								}

			   				}
			   		
					if (prev) _NEXFinish(prev.nombre);								
			   		}
			   		//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
}



/*******************************************************************************
**
** Function _NEXFinish2(item)
** Inputs:  @item: Elemento a finalizar (pagina)
** Return:  none
**
** Description:
** Calcula el estado final del elemento NO se propaga por el arbol.
**
*******************************************************************************/
function _NEXFinish2(item){

	
	var aux=item.toUpperCase();
   		var prev=null;
			aux=aux.substring(1,aux.length);
			var aux_array=aux.split("_");
					p=curso
					for (var z=0; z<aux_array.length;z++){
			   			try{
			   				prev=p;
			   			    p=p.children[Number(Number(aux_array[z])-1)];
						}
						catch (exception) {
						    p=null
						    //setError("La finalizacion del elemento: "+item+" ha generado el siguiente error: "+ String(exception));   						
      					}
		   			}
			   		if (p){
			   				var aux2=p.parametros
			   				var aux3=-1; //--->Nota de corte
			   				if (aux2.toLowerCase()=="a"){ //---> Habra que buscar la nota de corte.
			   					aux3=_NEXGetValue(diccionario[7][0])==""?50:_NEXGetValue(diccionario[7][0]);
			   				}
			   				else if (aux2.toLowerCase().indexOf("a")!=-1){ //---> Habra que extraer la nota de corte.
			   					aux3=aux2.toLowerCase().substr(1,aux2.toLowerCase().length);
			   				}
			   				else { //--->No hay nota de corte, es un bloque de teoria.
			   					aux3=-1  						
			   				}
			   				
			   				//Calculamos la nota media de los elementos de que se compone el bloque
			   				var puntuacion=0;
			   				var std="c"
			   				var counter=0;
			   				for (var z=0; z<p.children.length;z++){
			   					f=p.children[z];
			   					var aux4=f.estado;
			   						if ((aux4.toLowerCase()=="n") || (aux4.toLowerCase()=="i")){
			   							if(std!="i")std=aux4.toLowerCase();
			   							nota=-1;
			   						}
			   						else {
			   							if (aux4.toLowerCase()=="c"){
			   								puntuacion=Number(puntuacion)+0;			
			   							}
			   							else {
			   								counter++;
			   								var aux5=aux4.substr(1,aux4.length)
			   								puntuacion=Number(puntuacion)+Number(aux5);	
			   							}
			   						}
			   				}
			   				
			   				if (puntuacion==-1) p.estado=std;
			   				else {
			   					if (puntuacion!=0) {
				   					nota=parseInt(Number(Number(puntuacion)/Number(counter)), 10);
				   					if (Number(nota)<Number(aux3)){ //Si la nota es inferior a la nota de corte
											 p.estado="f"+nota;	
									}
									else { //Si la nota es superior a la nota de corte
										    p.estado="p"+nota;	
									}
								}
								else {
									if (aux3==-1) p.estado="c"
									else p.estado="f0";
								}

			   				}
			   											
			   		}
					//else setError("La busqueda del elemento: "+item+" ha generado el siguiente error: Element not found");
}

/*******************************************************************************
**
** Function _NEXGoNext(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Elemento siguiente(pagina)
**
** Description:
** Devuelve el siguiente elemento del mismo nodo, es decir, la siguient pagina a la actual.
** si no exites devuelve "" 
**
*******************************************************************************/
function _NEXGoNext(item){
	//setAction("_NEXGoNext("+item+")");
	var ans=new String("")
	var ob=_NEXFindSecuentItem(item);
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;
}

/*******************************************************************************
**
** Function _NEXGoActivityNext(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Elemento siguiente(pagina)
**
** Description:
** Devuelve el siguiente elemento (actividad) del mismo nodo, es decir, la siguient actividad a la actual.
** si no exites devuelve "" 
**
*******************************************************************************/
function  _NEXGoActivityNext(item){
	//setAction(" _NEXGoActivityNext("+item+")");
	var ans=new String("")
	var findEnd=false;
		ob=_NEXFindItem(item)
		while (!findEnd) {
			ob=_NEXFindSecuentItem(ob.nombre);
			if (ob) {
				var aux=ob.nombre.substr(0,1)
				if (aux=="A") findEnd=true;
			}
			else findEnd=true;
		}
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;
}

/*******************************************************************************
**
** Function _NEXGoNextBlock(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: Elemento siguiente(bloque)
**
** Description:
** Devuelve el siguiente elemento (bloque) del mismo nodo, es decir, la siguiente bloque al actual.
** si no exites devuelve ""
** Importante, si item no es un bloque, es una pagina, esta funcion devuelve la siguiente pagina. 
**
*******************************************************************************/
function _NEXGoNextBlock(item){
	//setAction(" _NEXGoNextBlock("+item+")");
	var ans=new String("")
	var ob=_NEXFindSecuentItem(item);
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;
}


/*******************************************************************************
**
** Function _NEXGoPrev(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Elemento anterior(pagina)
**
** Description:
** Devuelve el elemento anterior (pagina) del mismo nodo, es decir, la pagina anterior al actual.
** si no exites devuelve ""
** Importante, si item es un bloque, y no una pagina, esta funcion devuelve el bloque previo. 
**
*******************************************************************************/
function _NEXGoPrev(item){
	//setAction(" _NEXGoPrev("+item+")");
	var ans=new String("")
	var ob=_NEXFindPrevItem(item);
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;
}


/*******************************************************************************
**
** Function  _NEXGoActivityPrev (item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Elemento anterior(actividad)
**
** Description:
** Devuelve el elemento anterior (actividad) del mismo nodo, es decir, la actividad previa a la actual.
** si no exites devuelve "" 
**
*******************************************************************************/
function _NEXGoActivityPrev(item){
	//setAction(" _NEXGoActivityPrev("+item+")");
	var ans=new String("")
	var findEnd=false;
		ob=_NEXFindItem(item)
		while (!findEnd) {
			ob=_NEXFindPrevItem(ob.nombre);
			if (ob) {
				var aux=ob.nombre.substr(0,1)
				if (aux=="A") findEnd=true;
			}
			else findEnd=true;
		}
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;

}

/*******************************************************************************
**
** Function _NEXGoPrevBlock(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: Elemento anterior(bloque)
**
** Description:
** Devuelve el elemento anterior (bloque) del mismo nodo, es decir, el bloque anterior al actual.
** si no exites devuelve ""
** Importante, si item es una pagina, y no un bloque, esta funcion devuelve la pagina previa. 
**
*******************************************************************************/
function _NEXGoPrevBlock(item){
	//setAction(" _NEXGoPrevBlock("+item+")");
	var ans=new String("")
	var ob=_NEXFindPrevItem(item);
	if (ob) ans=ob.nombre.toLowerCase();
	return ans;
}

/*******************************************************************************
**
** Function _NEXTotalPages(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: Numero de paginas del (bloque)
**
** Description:
** Devuelve el numero de paginas del bloque. 
**
*******************************************************************************/
function _NEXTotalPages(item){
	//setAction(" _NEXTotalPages("+item+")");
	var ans=new Array();
	ans=_NEXCountChildItem (item)		
	return ans.length;
}


/*******************************************************************************
**
** Function _NEXTotalPagesBloc(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: Numero de paginas del (bloque)
**
** Description:
** Devuelve el numero de paginas del bloque. 
**
*******************************************************************************/
function _NEXTotalPagesBloc(item){
		//setAction(" _NEXTotalPagesBloc("+item+")");
		return _NEXTotalPages(item);
}


/*******************************************************************************
**
** Function _NEXTotalPagesBloc(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: Numero de paginas del (bloque)
**
** Description:
** Devuelve el numero de paginas del bloque. 
**
*******************************************************************************/
function _NEXTotalActivityPages(item){
	//setAction(" _NEXTotalActivityPages("+item+")");
	var aux=new Array();
	var aux2=_NEXCountChildItem(item);
	for (d=0;d<aux2.length;d++){
		if (aux2[d].substr(0,1)=="A") aux.push(aux2[d]);
	}
	return aux.length;
}

/*******************************************************************************
**
** Function _NEXTotalPrevPages(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Numero de paginas anteriores dentro del mismo bloque
**
** Description:
** Devuelve el numero de paginas que hay pordelante en su mismo bloque. 
**
*******************************************************************************/
function _NEXTotalPrevPages(item){
		//setAction("_NEXTotalPrevPages("+item+")");
		var p=_NEXFindParentItem(item);
		var count=0;
		for (d=0;d<p.children.length;d++){
		 if (p.children[d].nombre!=""){
		 		if (p.children[d].nombre.toUpperCase()==item.toUpperCase()){
		 		break;
		 		}
		 		else count++;
		 }
		}
		return count;
}


/*******************************************************************************
**
** Function _NEXTotalPrevBlocPages(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Numero de paginas anteriores dentro de todo el bloque
**
** Description:
** Devuelve el numero de paginas que hay pordelante en todo el bloque. 
**
*******************************************************************************/
function _NEXTotalPrevBlocPages(item){
	//setAction("_NEXTotalPrevBlocPages("+item+")");
	var count=_NEXTotalPrevPages(item);
	var p =_NEXFindParentItem(item)
	var p1=_NEXFindParentItem(p.nombre);
	if (p1){
		for (d=0;d<p1.children.length;d++){
		 if (p1.children[d].nombre!=""){
		 		if (p1.children[d].nombre.toUpperCase()==p.nombre.toUpperCase()){
			 		break;
		 		}
		 		else count=Number(count)+Number(_NEXTotalPages(p1.children[d].nombre));
			 }
		}
	}
	else {
	 	//setError("La busqueda del paren del parent de elemento: "+item+" ha generado el siguiente error: Element not found");
	}
	return count
}


/*******************************************************************************
**
** Function _NEXOrder(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans: Posicion que ocupa dentro del mismo bloque
**
** Description:
** Devuelve la posicion que ocupa la pagina el bloque. 
**
*******************************************************************************/
function  _NEXOrder(item){
	//setAction("_NEXOrder("+item+")");
	var count=1;
	count=Number(count)+Number(_NEXTotalPrevPages(item))
	return count;
}


/*******************************************************************************
**
** Function _NEXOrderActivity(item)
** Inputs:  @item: Elemento actual (actividad)
** Return:  @ans: Posicion que ocupa dentro del mismo bloque (solo cuentan las actividades)
**
** Description:
** Devuelve la posicion que ocupa la actividad dentro el bloque. 
**
*******************************************************************************/
function _NEXOrderActivity(item){
	    //setAction("_NEXOrderActivity("+item+")");
	    var p=_NEXFindParentItem(item);
		var count=1;
		for (d=0;d<p.children.length;d++){
		 if (p.children[d].nombre!=""){
		 		if (p.children[d].nombre.toUpperCase()==item.toUpperCase()){
		 		break;
		 		}
		 		else {
		 		var aux=p.children[d].nombre.toUpperCase()
			 		if (aux.substr(0,1)=="A") count++;
		 		}
		 }
		}
		return count;
}


/*******************************************************************************
**
** Function _NEXLast(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: elemento
**
** Description:
** Devuelve el ultimo elemento del bloque
**
*******************************************************************************/
function _NEXLast(item){
		//setAction("_NEXOrderActivity("+item+")");
	    var p=_NEXFindItem(item);
	    var ans=false;
	    p=p.children[p.children.length-1];
	    if (p){
	    	ans=p.nombre;
	    }
	    //else setError("La busqueda ultimo elemento de: "+item+" ha generado el siguiente error: Element not found");
		return ans
}

/*******************************************************************************
**
** Function _NEXLast(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: elemento
**
** Description:
** Devuelve la ultima pagina del ultimo elemento del bloque
**
*******************************************************************************/
function _NEXLastPage(item){
		//setAction("_NEXOrderActivity("+item+")");
		var ans=false;
		var p=_NEXFindItem(_NEXLast(item));
		
	    while(p.nombre.substr(0,1)=="B"){
	    	p=p.children[p.children.lenght-1];
	    	
	    }
	    if (p) ans=p.nombre
	    //else setError("La busqueda la ultima pagina de: "+item+" ha generado el siguiente error: Element not found");

		return ans;
}


/*******************************************************************************
**
** Function _NEXTheLastPage(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: elemento
**
** Description:
** Devuelve la ultima pagina del ultimo elemento del bloque
**
*******************************************************************************/
function _NEXTheLastPage(item){
	return _NEXLastPage(item)
}

/*******************************************************************************
**
** Function _NEXFirst(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: elemento
**
** Description:
** Devuelve el primer hijo del elemento bloque
**
*******************************************************************************/
function _NEXFirst(item){
	//setAction("_NEXFirst("+item+")");
	var ans=false;
	var p=_NEXFindChildrenItem(item,0);
    if(p){
			ans=p.nombre;
	}
	//else setError("La busqueda del primer elemento de: "+item+" ha generado el siguiente error: Element not found");
	return ans
}

/*******************************************************************************
**
** Function _NEXFirstActivity(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans: elemento
**
** Description:
** Devuelve la primera actividad del elemento bloque
**
*******************************************************************************/
function _NEXFirstActivity(item){
	//setAction("_NEXFirst("+item+")");
	var ans=new String("");
	var find=false;
	var count=0
	var p=_NEXFindChildrenItem(item,0);
	if ((p) && (p.nombre.substr(0,1)!="A")){
		while (_NEXFindSecuentItem(p.nombre) && !find){
		   p=_NEXFindSecuentItem(p.nombre);
		   if ((p) && (p.nombre.substr(0,1)=="A")) find=true;
		}
		
	}
	if(p && find){
			ans=p.nombre;
	}
	return ans

}

/*******************************************************************************
**
** Function _NEXTipoPreg(code)
** Inputs:  @code:String ---> Identificador de la tipologia de pregunta
** Return:  @ans: String ---> Cadena del identificadro de la tipologia de pregunta
**
** Description:
** Devuelve una cadena que identifica, segun SCORM, la tipologia de pregunta.
**
*******************************************************************************/
function _NEXTipoPreg(code){
	var ans=new String("");
	switch(code.toUpperCase())
    {
       case "C":
       {
          ans="choice"
          break;       
       }
       case "M":
       {
          ans="choice"	
          //ans="performance"	
          break;              
       }
       case "T":
       {
         //ans="true-false"	
         ans="performance"	
         break;              
       }
       case "R":
       {
          ans="matching"	
          break;              
       }
    }            
 	return ans;

}

/*******************************************************************************
**
** Function _NEXScore(item)
** Inputs:  @item: Elemento actual (pagina..bloque)
** Return:  @ans:number Puntuacion
**
** Description:
** Devuelve la puntacion de elemento de consulta. 
**
*******************************************************************************/
function _NEXScore(item){
		//setAction("_NEXScore("+item+")");
		var ans=false;
	    var p=_NEXFindItem(item);
	    if(p){
		    if((p.estado=="n")||(p.estado=="i")||(p.estado=="c")) ans=-1
		    else {
		    ans=Number(p.estado.substr(1,p.estado.length))
		    }
		}
		//else setError("La busqueda del la puntuacio de elemento: "+item+" ha generado el siguiente error: Element not found");
		return ans
}

/*******************************************************************************
**
** Function _NEXActualScore(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans:number Puntuacion
**
** Description:
** Devuelve la puntacion de las actividades del bloque. 
**
*******************************************************************************/
function _NEXActualScore(item){
		//setAction("_NEXScore("+item+")");
		var ans=false;
		var count=0;
		var puntuacion=0;
		var p=_NEXFindItem(item);
	    if(p){
		    if((p.estado=="n")||(p.estado=="i")||(p.estado=="c")) ans=-1
		    else {
		    	for (d=0;d<p.children.length;d++){
		    		if (p.children[d].nombre.substr(0,1)=="A"){
		    			count++
		    			puntuacion=Number(puntuacion)+Number(p.children[d].estado.substr(1,p.estado.length))
		    		}
		    	}
		    ans=Number(puntuacion/count);
		    }
		}
		//else setError("La busqueda del la puntuacio de elemento: "+item+" ha generado el siguiente error: Element not found");
		return ans
}


/*******************************************************************************
**
** Function _NEXStatus(item)
** Inputs:  @item: Elemento actual (pagina..bloque)
** Return:  @ans:string stado
**
** Description:
** Devuelve estado de elemento de consulta. 
**
*******************************************************************************/
function _NEXStatus(item){
	    //setAction("_NEXStatus("+item+")");
	    var ans=false;
	    var p=_NEXFindItem(item);
	    if(p){
		    ans=p.estado.substr(0,1).toUpperCase();
		}
		//else setError("La busqueda del la puntuacio de elemento: "+item+" ha generado el siguiente error: Element not found");
		return ans
}

/*******************************************************************************
**
** Function _NEXCurrent(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans:string elemento (bloque) 
**
** Description:
** Devuelve el suguiente elemento incompleto
**
*******************************************************************************/
function _NEXCurrent(item){
	//setAction("_NEXStatus("+item+")");
	var ans=new String("");
	var p=_NEXFindItem(item);
	if ((p.estado=="n") || (p.estado=="i")){
		p=p.children[0];
		var find=false;
        if(p){
    	  while(p && !find){
		   if ((p.estado=="n") || (p.estado=="i")) find=true;
		   else  p=_NEXFindSecuentItem(p.nombre)
		  }
		 if (find) ans=p.nombre;
       }
	   //else setError("La busqueda del la puntuacio de elemento: "+item+" ha generado el siguiente error: Element not found");
	}
	return ans
}

/*******************************************************************************
**
** Function _NEXFirstIncorrectActivity(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans:string elemento (pagina) 
**
** Description:
** Devuelve la primera activodad incorrecta
**
*******************************************************************************/
function _NEXFirstIncorrectActivity(item){
    //setAction("_NEXFirstIncorrectActivity("+item+")");
    var ans=new String("");
	var find=false;
	var count=0
	var p=_NEXFindChildrenItem(item,0);
	if ((p) && (p.nombre.substr(0,1)!="A")){
		while (_NEXFindSecuentItem(p.nombre) && !find){
		   p=_NEXFindSecuentItem(p.nombre);
		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="f")) find=true;
		}
		
	}
	if(p && find){
			ans=p.nombre;
	}
	return ans
}

/*******************************************************************************
**
** Function _NEXFirstIncorrectActivity(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  @ans:string elemento (pagina) 
**
** Description:
** Devuelve la primera activodad con estado igual a N
**
*******************************************************************************/
function _NEXFirstNoAttep(item){
	var ans=new String("");
	var find=false;
	var count=0
	var p=_NEXFindChildrenItem(item,0);
	//alert(p)
	if (p){
		//alert(p.nombre)
		if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="n")) find=true;
        if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="i")) find=true;
        //alert(p.nombre + ":" + find)
		while (_NEXFindSecuentItem(p.nombre) && !find){
		   p=_NEXFindSecuentItem(p.nombre);
		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="n")) find=true;
		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="i")) find=true;
		}
		
	}
	if(p && find){
			ans=p.nombre;
	}
	return ans
}
/*******************************************************************************
**
** Function _NEXForce(item, stado)
** Inputs:  @item: Elemento 
			@stado:Estado;
** Return:  
**
** Description:
** Fuerza el estado (nota) de un elemento
**
*******************************************************************************/
function _NEXForce(item, stado){
	var p=_NEXFindItem(item);
		if (p){
			p.estado=stado;
		}
}
/*******************************************************************************
**
** Function _NEXNextNoAttepActivity(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans:string elemento (pagina) 
**
** Description:
** Devuelve la primera siguiente actividad incorrecta
**
*******************************************************************************/
function _NEXNextNoAttepActivity(item){
    
    var ans=new String("");
    var find=false;
    var p=_NEXFindItem(item);
    while (_NEXFindSecuentItem(p.nombre) && !find){
   		 p=_NEXFindSecuentItem(p.nombre);
   		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="n")) find=true;
		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="i")) find=true;
    }
    if(p && find){
			ans=p.nombre;
	}
    return ans
}


/*******************************************************************************
**
** Function _NEXNextIncorrectActivity(item)
** Inputs:  @item: Elemento actual (pagina)
** Return:  @ans:string elemento (pagina) 
**
** Description:
** Devuelve la primera siguiente actividad incorrecta
**
*******************************************************************************/
function _NEXNextIncorrectActivity(item){
    //setAction("_NEXFirstIncorrectActivity("+item+")");
    var ans=new String("");
    var find=false;
    var p=_NEXFindItem(item);
    while (_NEXFindSecuentItem(p.nombre) && !find){
    	 p=_NEXFindSecuentItem(p.nombre);
		   if ((p) && (p.nombre.substr(0,1)=="A") && (p.estado.substr(0,1)=="f")) find=true;
    }
    if(p && find){
			ans=p.nombre;
	}
    return ans
}


/*******************************************************************************
**
** Function _NEXGetParameters()
** Inputs:  none
** Return:  @ans:string de paremtros auxiliares 
**
** Description:
** Devuelve la cadena de parametros auxiliares.
**
*******************************************************************************/
function _NEXGetParameters(){
    //setAction("_NEXGetParameters()");
    var ans=new String("");
    	ans=_NEXGetValue(diccionario[2][0]);
    /*	locationSplit = ans.split("#|");
	if(locationSplit.length > 1) {
	ans=locationSplit[0] 	
	}*/
    	return ans;
}

/*******************************************************************************
**
** Function _NEXSetParameters(item)
** Inputs:  @item:string de paremtros auxiliares
** Return:  none
**
** Description:
** Guarda la cadena de parametros auxiliares.
**
*******************************************************************************/
function _NEXSetParameters(item){
	/*var aux=new String("");
    	aux=_NEXGetValue(diccionario[2][0]);
    	alert("_NEXSetParameters: " + aux)
    	locationSplit = aux.split("#|");
	if(locationSplit.length > 1) {
	locationSplit[0]=item
	}
	item=locationSplit.join("#|");
	*/
	_NEXSetValue(diccionario[2][0],item);
	return true;
}

/*******************************************************************************
**
** Function _NEXCreateObjective(item)
** Inputs:  @item:Array de datos de Objetivod
** Return:  @listaObjetivos : Array con los datos de los Objetivod;
**
** Description:
** Crea los objetivos.
**
*******************************************************************************/
function _NEXCreateObjective(item){
	 listaObjetivos=new Array();
	 listaObjetivos=item;
	 var ans=new Array();
	 var api = NEXAPI;
	 if (api != extAPI){
		 	if (extAPI.LMSGetValue ('cmi.objectives._count')==0){
		 		for (var d=0;d<listaObjetivos.length;d++){
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.id', listaObjetivos[d][1]);
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.score','');
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.score.raw',listaObjetivos[d][2]);
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.score.max',listaObjetivos[d][3]);
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.score.min',listaObjetivos[d][4]);
					extAPI.LMSSetValue ('cmi.objectives.'+d+'.status','not attempted');
					listaObjetivos[d][5] ="N";
				}
			}
			else {
				for (var d=0;d<listaObjetivos.length;d++){
				listaObjetivos[d][2] = extAPI.LMSGetValue ('cmi.objectives.'+d+'.score.raw');
				var aux= extAPI.LMSGetValue ('cmi.objectives.'+d+'.status');
				listaObjetivos[d][5]= aux.substring(0,1).toUpperCase();
				}
			}
	 }
	 else{
	 	if (_NEXGetValue('objetivos')==""){
	 		var str="";
	 		for (var d=0;d<listaObjetivos.length;d++){
	 			listaObjetivos[d][5] ="N";
	 			if (str=="") str+=listaObjetivos[d].join(",");
	 			else str+="@"+listaObjetivos[d].join(",");
			}
			_NEXSetValue('objetivos', str);
	 	}
	 	else{
	 		
	 		var aux=_NEXGetValue('objetivos')
	 		var aux2=new Array();
	 			aux2=aux.split("@");
	 		for (var d=0;d<listaObjetivos.length;d++){
	 			var tTemp=aux2[d].split(",");
	 			listaObjetivos[d][2]=tTemp[2];
				listaObjetivos[d][5]=tTemp[5];
			}
	 	}
	 
	 }
	 ans=listaObjetivos;
	 return ans;
}


/*******************************************************************************
**
** Function _NEXGetObjective(item)
** Inputs:  @item:string de paremtros auxiliares
** Return:  Array con los valores del Objetivo
**
** Description:
** Recupera los datos del Objetivo.
**
*******************************************************************************/
function _NEXGetObjective(Id){
	 var ans=new Array(6);
	//No se ha de ejecutar en la version cookies
	   var api = NEXAPI;
	   if (api != extAPI){
	   		for (var d=0;d<listaObjetivos.length;d++){
	   			if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase()){
	   				ans[0]=listaObjetivos[d][0]; //Codigo
	   				ans[1]=listaObjetivos[d][1]; //Nombre
	   				ans[2]=extAPI.LMSGetValue ('cmi.objectives.'+d+'.score.raw'); //Nota
	   				ans[3]=listaObjetivos[d][3]; //Nota Maxima
	   				ans[4]=listaObjetivos[d][4]; //Nota Minima
	   				ans[5]=extAPI.LMSGetValue ('cmi.objectives.'+d+'.status'); //Estado
	   				break;
				}
	   		}
	   }
	   else {
	   		for (var d=0;d<listaObjetivos.length;d++){
	   			if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase()){
	   				ans[0]=listaObjetivos[d][0]; //Codigo
	   				ans[1]=listaObjetivos[d][1]; //Nombre
	   				ans[2]=listaObjetivos[d][2]; //Nota
	   				ans[3]=listaObjetivos[d][3]; //Nota Maxima
	   				ans[4]=listaObjetivos[d][4]; //Nota Minima
	   				ans[5]=listaObjetivos[d][5] //Estado
	   				break;
				}
	   		}

	   }
	   return ans;
}


/*******************************************************************************
**
** Function _getStadoString(estado)
** Inputs:  @estado:Caracter que identifica el estado
** Return:  ans : Literal del estado;
**
** Description:
** Recupera el literal de un estado.
**
*******************************************************************************/
function _getStadoString(estado){
	
	var ans=new String("");
	switch(estado.toUpperCase())
    {
       case "N":
       {
          ans="not attempted"
          break;       
       }
       case "I":
       {
          ans="incomplete"	
          break;              
       }
       case "C":
       {
         ans="completed"	
         break;              
       }
       case "P":
       {
          ans="passed"	
          break;              
       }
       case "F":
       {
          ans="failed"	
          break;              
       }
       default:
       {
         ans="incomplete"	         
       }
    }            
 	return ans;
 
}


/*******************************************************************************
**
** Function _NEXSetObjective(Id)
** Inputs:  @Id:Identificacion del Objetivo
** Return:  none
**
** Description:
** Guarda el Objetivo, solo si ha habido cambio de estado o se ha mejorado la nota...
**
*******************************************************************************/
function _NEXSetObjective(Id){
		 //No se ha de ejecutar en la version cookies
		 var api = NEXAPI;
		 if (api != extAPI){
		 		status = _NEXStatus(Id)
				statusText = _getStadoString(status);
			    score=_NEXScore(Id)==-1?'':_NEXScore(Id).toString();
				for (var d=0;d<listaObjetivos.length;d++){
				//Solo se guardara si hay cambio de estado o nota....
					if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase() && ((score!=listaObjetivos[d][2])||(status!=listaObjetivos[d][5]))){
						//Para evitar problemas.... solo se guadara el objetivo si la puntuacion nueva es mayor que la anterior	o igual y el estado es diferente
						if (Number(score) >= Number(listaObjetivos[d][2])){
							extAPI.LMSSetValue ('cmi.objectives.'+d+'.score.raw',score);
							extAPI.LMSSetValue ('cmi.objectives.'+d+'.status',statusText);
							listaObjetivos[d][2] = score;
							listaObjetivos[d][5]= statusText.substring(0,1).toUpperCase();
						}
						break;
					}
			  }
		 }
		 else {
		 		status = _NEXStatus(Id)
				statusText = _getStadoString(status);
			    score=_NEXScore(Id)==-1?'':_NEXScore(Id).toString();
				for (var d=0;d<listaObjetivos.length;d++){
				//Solo se guardara si hay cambio de estado o nota....
					if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase() && ((score!=listaObjetivos[d][2])||(status!=listaObjetivos[d][5]))){
						//Para evitar problemas.... solo se guadara el objetivo si la puntuacion nueva es mayor que la anterior	o igual y el estado es diferente
						if (Number(score) >= Number(listaObjetivos[d][2])){
							listaObjetivos[d][2] = score;
							listaObjetivos[d][5]= statusText.substring(0,1).toUpperCase();
							guardaCookiesObj();	
						}
						break;
					}
			  }

		 }
}

/*******************************************************************************
**
** Function guardaCookiesObj()
** Inputs:  none
** Return:  none
**
** Description:
** Guarda los objetivos en la Cookie;
**
*******************************************************************************/
function guardaCookiesObj(){
			var str="";
	 		for (var d=0;d<listaObjetivos.length;d++){
	 			if (str=="") str+=listaObjetivos[d].join(",");
	 			else str+="@"+listaObjetivos[d].join(",");
			}
			_NEXSetValue('objetivos', str)
}

/*******************************************************************************
**
** Function _NEXSetForceObjective(Id, score, status)
** Inputs:  @Id:Identificacion del Objetivo
			@score:Nota
			@status:Estado
** Return:  none
**
** Description:
** Fuerza la nota y estado del Objetivo
**
*******************************************************************************/
function _NEXSetForceObjective(Id, score, status){
		 var api = NEXAPI;
		 if (api != extAPI){
		 		statusText = _getStadoString(status);
				for (var d=0;d<listaObjetivos.length;d++){
					if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase()){
						extAPI.LMSSetValue ('cmi.objectives.'+d+'.score.raw',score);
						extAPI.LMSSetValue ('cmi.objectives.'+d+'.status',statusText);
						listaObjetivos[d][2] = score;
						listaObjetivos[d][5]= statusText.substring(0,1).toUpperCase();
						break;
					}
				}
		 }
		 else {
		 		status = _NEXStatus(Id)
				statusText = _getStadoString(status);
			    score=_NEXScore(Id)==-1?'':_NEXScore(Id).toString();
				for (var d=0;d<listaObjetivos.length;d++){
					if (Id.toUpperCase()==listaObjetivos[d][0].toUpperCase()){
						listaObjetivos[d][2] = score;
						listaObjetivos[d][5]= statusText.substring(0,1).toUpperCase();
						guardaCookiesObj();	
						break;
					}
			  }
		 }
}

/*******************************************************************************
**
** Function _NEXSetIteraction(item,resposta,tipus,result,correcta,nota,timeSpend,timeEnd)
** Inputs:  @item:String -->Actividad que origina la iteracion
**			@resposta:String --> Respuesta dada por el usuario
**			@tipus:String --> Tipologia de la pregunta respondida
**			@result:String --> Indica si esta Correcto o incorrecto
**			@correcta:String --> Respuesta correcta del ejercicio
**			@nota:number ---> Puntuacion obtenida en la activad
**			@timeSpend:time ---> Tiempo gastado en la actividad
**			@timeEnd:time ---> Hora de finalizacion de la actividad
** 
** Return:  none
**
** Description:
** Gestiona la iteraccion.
**
*******************************************************************************/
function _NEXSetIteraction(item,resposta,tipus,result,correcta,nota,timeSpend,timeEnd,objetivoActual){
		 //No se ha de ejecutar en la version cookies
		 var api = NEXAPI;
		 if (api != extAPI){
				tipus=_NEXTipoPreg(tipus);		
				if (result == "c") result = "correct";
				if (result == "w") result = "wrong";
				resposta=resposta.toString().replace(/;/gi,",");
				correcta=correcta.toString().replace(/;/gi,",");
			
				/*
				No se utiliza, en funcion del proyecto puede ser necesario activar esta opcion y pasar los parametros adecuados
				objetivoActual= parent.sup.getObjAct(bloqueActual);
				*/
				
				//alert('_NEXSetIteraction: ' + resposta+', '+tipus+', '+result+', '+correcta+', '+nota +', '+timeSpend+', '+timeEnd);
				
				var temp = "";	
					temp = _NEXLMSGetValue("cmi.interactions._count");
				
					if (item)			_NEXLMSSetValue("cmi.interactions." + temp + ".id",item);
					if (objetivoActual)	_NEXLMSSetValue("cmi.interactions." + temp + ".objectives.0.id",objetivoActual);
					if (timeEnd)		_NEXLMSSetValue("cmi.interactions." + temp + ".time", timeEnd);
					if (timeSpend)		_NEXLMSSetValue("cmi.interactions." + temp + ".latency",timeSpend);
					if (tipus)			_NEXLMSSetValue("cmi.interactions." + temp + ".type",tipus);
					if (resposta)		_NEXLMSSetValue("cmi.interactions." + temp + ".student_response",resposta);
					if (correcta)		_NEXLMSSetValue("cmi.interactions." + temp + ".correct_responses.0.pattern" ,correcta);
					if (result)			_NEXLMSSetValue("cmi.interactions." + temp + ".result",result);
		 }
		 
}


/*******************************************************************************
**
** Function _NEXResetPage(item)
** Inputs:  @item: Elemento actual (actividad)
** Return:  none 
**
** Description:
** Pone a N, el estado de la actividad pasada por parametro
**
*******************************************************************************/
function  _NEXResetPage(item){
	var p = _NEXFindItem(item)
	if (p) {
		p.estado="n";
		//alert("_NEXResetPage: "+p.estado)
	}
	else{
	 //setError("La busqueda de elemento: "+item+" ha generado el siguiente error: Element not found");
	}
 
}


/*******************************************************************************
**
** Function _NEXResetBlock(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  none 
**
** Description:
** Pone a N, todos los subelementos Actividad de un bloque
**
*******************************************************************************/
function _NEXResetBlock(item){
       var aux = _NEXFirst(item);
       var aux2 = "" 
   while(aux!="")
   {
   	 aux2 = aux.substr(0,1)
     if ( aux2.toUpperCase()=="A") 
     {
                 _NEXResetPage(aux); 

     }
     aux = _NEXGoNext(aux);
   }
}


/*******************************************************************************
**
** Function _NEXResetIncBlock(item)
** Inputs:  @item: Elemento actual (bloque)
** Return:  none 
**
** Description:
** Pone a N, todos los subelementos Actividad de un bloque
**
*******************************************************************************/

function _NEXResetIncBlock(item){
   var aux = _NEXFirst(item);
   var aux2 ="";
   var aux3 ="";
   while(aux!=""){
   	  aux2 = aux.substr(0,1)
	  aux3 = _NEXStatus(aux);
	  //alert(aux2 +"|"+ aux3)
     if ((aux2.toUpperCase()=="A")&&(aux3.toLowerCase()=="f"))
     {
                 _NEXResetPage(aux); 

     }
     aux = _NEXGoNext(aux);
   }
}

/*******************************************************************************
**
** Function _NEXGetHashParameter(param)
** Inputs:  @param:Parametro a localizar
** Return:  @ans: valor paramtreo
**
** Description:
** Devuelve el parametro selecionado
**
*******************************************************************************/
function _NEXGetHashParameter(param)
{
	var api = NEXAPI;    
	var lesson_location = "";    
   
	lesson_location = _NEXGetValue(diccionario[2][0]);
	str_location = new String (lesson_location);   
	parameters = "";
	locationSplit = str_location.split("#|");
	if(locationSplit.length > 1) {
    	parameters = locationSplit[1].split("|");
		for(i=0;i<parameters.length;i++) {
			// pv = parameters[i].split("=");
			pv = parameters[i].split(":");
			if(pv[0]==param) return pv[1];
		}
	}
	
	return null;		 
}

/**
 * _NEXSetHashParameter
 * @date 03/06/2004
 * Extrae el valor del parametro param de la cadena tras la hash-pipe en el lesson_location.
 * Si no existe devuelve null.
 */
  
function _NEXSetHashParameter(param,val)
{
	var api = NEXAPI;    
	var lesson_location = "";    
   
	lesson_location = _NEXGetValue(diccionario[2][0]);
	str_location = new String (lesson_location);   
	parameters = "";
   
	locationSplit = str_location.split("#|");
	temp = locationSplit[0];
	
	encontrado = false;
	if(locationSplit.length > 1) {
    	parameters = locationSplit[1].split("|");
		for(i=0;i<parameters.length;i++) {
			// pv = parameters[i].split("=");
			pv = parameters[i].split(":");
			if(pv[0]==param) {
				// parameters[i] = param + "=" + val;
				parameters[i] = param + ":" + val;
				encontrado = true;
			}
		}
	} else 
		parameters = new Array();
	if (!encontrado)
		parameters.push(param+":"+val);
		locationSplit = parameters.join("|");
		temp = temp + "#|" + locationSplit;
		_NEXSetValue(diccionario[2][0], temp);
	
}


function _NEXGetEstructura(){
	var api = NEXAPI;
	var aux1 = new String(_NEXGetValue(diccionario[4][0]));
  	    aux1 = aux1.toUpperCase();
	    return aux1
}

function _NEXGetEstados(){
	
	var api = NEXAPI;
	_NEXPrepareData();
	var aux1 = new String(_NEXGetValue(diccionario[3][0]));
	    aux1 = aux1.toUpperCase();
	    return aux1
}



new NEXE_API();
//Parametros
NEXE_API.prototype.NEXGlobalInitialize=_NEXGlobalInitialize;
NEXE_API.prototype.NEXGlobalCommit=_NEXGlobalCommit;
NEXE_API.prototype.NEXGlobalFinish=_NEXGlobalFinish;
NEXE_API.prototype.NEXGlobalGetValue=_NEXGlobalGetValue;
NEXE_API.prototype.NEXLMSGetValue=_NEXLMSGetValue;
NEXE_API.prototype.NEXLMSSetValue=_NEXLMSSetValue;
NEXE_API.prototype.NEXGetValue=_NEXGetValue;
NEXE_API.prototype.NEXSetValue=_NEXSetValue;
NEXE_API.prototype.NEXInitializeCourse=_NEXInitializeCourse;
NEXE_API.prototype.NEXPrepareCourse=_NEXPrepareCourse;
NEXE_API.prototype.NEXPrepareData=_NEXPrepareData;
NEXE_API.prototype.NEXFindItem=_NEXFindItem;
NEXE_API.prototype.NEXFindParentItem=_NEXFindParentItem;
NEXE_API.prototype.NEXFindChildrenItem=_NEXFindChildrenItem;
NEXE_API.prototype.NEXFindSecuentItem=_NEXFindSecuentItem;
NEXE_API.prototype.NEXFindPrevItem=_NEXFindPrevItem;
NEXE_API.prototype.NEXCountChildItem=_NEXCountChildItem;
NEXE_API.prototype.NEXCountFirstChildItem=_NEXCountFirstChildItem

//Acciones de Estado
NEXE_API.prototype.NEXInitialize = _NEXInitialize;
NEXE_API.prototype.NEXLoadPage = _NEXLoadPage;
NEXE_API.prototype.NEXUnLoadPage = _NEXUnLoadPage;
NEXE_API.prototype.NEXFinishActivity=_NEXFinishActivity;
NEXE_API.prototype.NEXForceActivity=_NEXForceActivity;
NEXE_API.prototype.NEXForce=_NEXForce;
NEXE_API.prototype.NEXFinish=_NEXFinish;
NEXE_API.prototype.NEXFinish2=_NEXFinish2;

//Navegacion
NEXE_API.prototype.NEXGoNext=_NEXGoNext;
NEXE_API.prototype.NEXGoActivityNext = _NEXGoActivityNext;
NEXE_API.prototype.NEXGoNextBlock = _NEXGoNextBlock;
NEXE_API.prototype.NEXGoPrev = _NEXGoPrev;
NEXE_API.prototype.NEXGoActivityPrev = _NEXGoActivityPrev;
NEXE_API.prototype.NEXGoPrevBlock = _NEXGoPrevBlock;
NEXE_API.prototype.NEXTotalPages = _NEXTotalPages;
NEXE_API.prototype.NEXTotalPagesBloc = _NEXTotalPagesBloc;
NEXE_API.prototype.NEXTotalActivityPages = _NEXTotalActivityPages;
NEXE_API.prototype.NEXTotalPrevPages = _NEXTotalPrevPages;
NEXE_API.prototype.NEXTotalPrevBlocPages = _NEXTotalPrevBlocPages;
NEXE_API.prototype.NEXOrder = _NEXOrder;
NEXE_API.prototype.NEXOrderActivity = _NEXOrderActivity;
NEXE_API.prototype.NEXLast = _NEXLast;
NEXE_API.prototype.NEXLastPage = _NEXLastPage;
NEXE_API.prototype.NEXTheLastPage=_NEXTheLastPage;
NEXE_API.prototype.NEXFirst = _NEXFirst;
NEXE_API.prototype.NEXFirstActivity = _NEXFirstActivity;
NEXE_API.prototype.NEXTipoPreg=_NEXTipoPreg;

//Consultas Estado y puntuacion
NEXE_API.prototype.NEXScore = _NEXScore;
NEXE_API.prototype.NEXActualScore = _NEXActualScore;
NEXE_API.prototype.NEXStatus = _NEXStatus;


//Consultas navegacion segun el estado o puntuacion
NEXE_API.prototype.NEXCurrent=_NEXCurrent;
NEXE_API.prototype.NEXFirstIncorrectActivity = _NEXFirstIncorrectActivity;
NEXE_API.prototype.NEXFirstNoAttep=_NEXFirstNoAttep;
NEXE_API.prototype.NEXNextIncorrectActivity = _NEXNextIncorrectActivity;
NEXE_API.prototype.NEXNextNoAttepActivity = _NEXNextNoAttepActivity;


//Gestion
NEXE_API.prototype.NEXGetParameters = _NEXGetParameters;
NEXE_API.prototype.NEXSetParameters = _NEXSetParameters;
NEXE_API.prototype.NEXCreateObjective = _NEXCreateObjective;
NEXE_API.prototype.NEXGetObjective = _NEXGetObjective;
NEXE_API.prototype.NEXSetObjective = _NEXSetObjective;
NEXE_API.prototype.NEXSetForceObjective = _NEXSetForceObjective;
NEXE_API.prototype.NEXSetIteraction = _NEXSetIteraction;
NEXE_API.prototype.NEXResetBlock = _NEXResetBlock;
NEXE_API.prototype.NEXResetIncBlock=_NEXResetIncBlock;
NEXE_API.prototype.NEXResetPage = _NEXResetPage;

NEXE_API.prototype.NEXGetHashParameter = _NEXGetHashParameter;
NEXE_API.prototype.NEXSetHashParameter = _NEXSetHashParameter
NEXE_API.prototype.NEXGetEstructura = _NEXGetEstructura;
NEXE_API.prototype.NEXGetEstados = _NEXGetEstados;